/* clrscr(), cputcxy(), screensize(), kbhit() */
#include <conio.h>
/* malloc(), free(), EXIT_SUCCESS */ 
#include <stdlib.h>

#define OBEN   0
#define RECHTS 1
#define UNTEN  2
#define LINKS  3
#define ANZAHL_BLICKRICHTUNGEN 4

#define PUNKT 'O'
#define LEER ' '

typedef struct {
  unsigned char positionX;
  unsigned char positionY;
  unsigned char blickrichtung;
} ameisenTyp;

unsigned char bildschirmX;
unsigned char bildschirmY;
unsigned char* bildschirm;

void InitialisierungAmeise(ameisenTyp *ameisenZeiger) {
  unsigned char xHalf;
  __asm__ ("lda %v", bildschirmX);
  __asm__ ("clc");
  __asm__ ("ror");
  __asm__ ("ldy #%o", xHalf);
  __asm__ ("sta (sp),y");
  (*ameisenZeiger).positionX = xHalf;
  /*(*ameisenZeiger).positionX = bildschirmX / 2;*/
  (*ameisenZeiger).positionY = bildschirmY / 2;
  (*ameisenZeiger).blickrichtung = UNTEN;
}

void InitialisierungBildschirm() {
  unsigned int bildschirmGroesse;
  unsigned int i;

  clrscr();
  screensize(&bildschirmX, &bildschirmY);
  bildschirmGroesse = (unsigned int)bildschirmX*(unsigned int)bildschirmY;
  bildschirm = (unsigned char*) malloc (bildschirmGroesse);
  for (i=0; i<bildschirmGroesse; i++){
    bildschirm[i] = LEER;
  }
}

void FreigabeBildschirm() {
  free((void*)bildschirm);
}

void SchreibeBildschirm(unsigned char x, unsigned char y, unsigned char c){
  unsigned int position;
  position = (unsigned int)(bildschirmX)*(unsigned int)y+(unsigned int)x;
  bildschirm[position] = c;
  cputcxy (x, y, c);
}

unsigned char LeseBildschirm(unsigned char x, unsigned char y){
  int position;
  position = (unsigned int)(bildschirmX)*(unsigned int)y+(unsigned int)x;
  return bildschirm[position];
}

void Schritt(ameisenTyp *ameisenZeiger) {
  switch ((*ameisenZeiger).blickrichtung) {
  case OBEN:
    (*ameisenZeiger).positionY = ((*ameisenZeiger).positionY + bildschirmY - 1)%bildschirmY;
    break;
  case UNTEN:
    (*ameisenZeiger).positionY = ((*ameisenZeiger).positionY + bildschirmY + 1)%bildschirmY;
    break;
  case LINKS:
    (*ameisenZeiger).positionX = ((*ameisenZeiger).positionX + bildschirmX - 1)%bildschirmX;
    break;
  case RECHTS:
    (*ameisenZeiger).positionX = ((*ameisenZeiger).positionX + bildschirmX + 1)%bildschirmX;
    break;
  }
}

void DrehungLinks(ameisenTyp *ameisenZeiger) {
  (*ameisenZeiger).blickrichtung = ((*ameisenZeiger).blickrichtung + ANZAHL_BLICKRICHTUNGEN - 1)%ANZAHL_BLICKRICHTUNGEN;
}

void DrehungRechts(ameisenTyp *ameisenZeiger) {
  (*ameisenZeiger).blickrichtung = ((*ameisenZeiger).blickrichtung + ANZAHL_BLICKRICHTUNGEN + 1)%ANZAHL_BLICKRICHTUNGEN;
}

void Regel1(ameisenTyp *ameisenZeiger) {
  SchreibeBildschirm((*ameisenZeiger).positionX, (*ameisenZeiger).positionY, PUNKT);
  DrehungRechts(ameisenZeiger);
  Schritt(ameisenZeiger);
}

void Regel2(ameisenTyp *ameisenZeiger) {
  SchreibeBildschirm((*ameisenZeiger).positionX, (*ameisenZeiger).positionY, LEER);
  DrehungLinks(ameisenZeiger);
  Schritt(ameisenZeiger);
}

void Berechnung(ameisenTyp *ameisenZeiger) {
  if(LeseBildschirm((*ameisenZeiger).positionX, (*ameisenZeiger).positionY) == LEER) {
    Regel1(ameisenZeiger);
  }
  else{
    Regel2(ameisenZeiger);
  }
}

int main (void){
  ameisenTyp ameise;
  unsigned char keyPressed=0;

  InitialisierungBildschirm();
  InitialisierungAmeise(&ameise);
  while (!keyPressed) {
    Berechnung(&ameise);
    keyPressed = kbhit();
  }
  FreigabeBildschirm();

  return EXIT_SUCCESS;
}

